Silo - Bug # 419: DBCreate segfaults when it fails to open the file when using the PDB driver

Status: Resolved Priority: Normal
Author: Jakob van Bethlehem Category:

Created: 10/08/2010 Assigned to: Mark Miller
Updated: 08/29/2012 Due date:

Likelihood: 2 - Rare

Severity: 4 - Crash / Wrong Results

Silo Found in Version: 4.7.2

os: All

Support Group: Any

Subject: DBCreate segfaults when it fails to open the file when using the PDB driver
Description: Suppose | have the following:
string const dbname("output/3d_outplace.silo");
And somewhere along in the code:
DBfile *silodb = DBCreate(dbname.c_str(), DB_NOCLOBBER, DB_LOCAL, NULL, DB_PDB);
Now suppose that the directory ‘output’ doesn't exist yet. In that case the file can't be created. When using
the DB_PDB as above, a 'Segmentation fault' results.
However, if | do the same with the HDF5 driver:
DBfile *silodb = DBCreate(dbname.c_str(), DB_NOCLOBBER, DB_LOCAL, NULL, DB_HDFS5);
In this scenario a clear errormessage results and the program continuous, allowing to check for NULL on this
pointer and deal with it accordingly:
DBCreate: File not found or invalid permissions: output/3d_outplace.silo
I'd suspect this is a bug in the standard PDB driver. A simple work-around is to use the HDF5 driver, even
though that introduces (maybe unwanted) dependencies into the code.
Other info:
$ uname -a
Linux feynman 2.6.18-194.17.1.el5 #1 SMP Wed Sep 29 12:50:31 EDT 2010 x86_64 x86_64 x86_64
GNU/Linux
$ g++ --version
g++ (GCC) 4.1.2 20080704 (Red Hat 4.1.2-48)
Invocation of ./configure script with HDF5:
$ Jconfigure --prefix=3STOWDIR/silo-4.7.2_h5/ --enable-silex --enable-browser
--with-hdf5=$MYSOFT/include,$MYSOFT/lib
For the PDB version it doesn't make a difference if the library was built with or without the HDF5 driver (eg: |
have tried both methods and they give the same outcome)
History

01/06/2011 11:00 pm - Mark Miller

- Target version set to 4.9
- Estimated time set to 2.00

I think it would work if you had DB_CLOBBER instead of DB_NOCLOBBER. There is logic in Silo to handle this (above the drivers) but | am guessing
it is triggered only for the CLOBBER case.
08/29/2012 02:21 pm - Mark Miller

- Status changed from New to Resolved

- Assigned to set to Mark Miller

- Priority changed from Urgent to Normal

- Estimated time changed from 2.00 to 0.25

- Likelihood changed from 5 - Always to 2 - Rare

| set priority to normal and likelihood to rare as across silo usage that | am aware of this, this comes up very rarely. Nonetheless, | have found and

fixed the problem.
